import 'package:flutter/rendering.dart';
import 'package:flutter_smartlook/wireframe/element_descriptors/abstract_descriptors/default_element_descriptor.dart';
import 'package:flutter_smartlook/wireframe/element_descriptors/not_visible_descriptors/render_opacity_descriptor.dart';
import 'package:flutter_smartlook/wireframe/element_descriptors/not_visible_descriptors/render_padding_descriptor.dart';
import 'package:flutter_smartlook/wireframe/element_descriptors/visible_descriptors/render_android_view_descriptor.dart';
import 'package:flutter_smartlook/wireframe/element_descriptors/visible_descriptors/render_custom_paint_descriptor.dart';
import 'package:flutter_smartlook/wireframe/element_descriptors/visible_descriptors/render_decorated_box_descriptor.dart';
import 'package:flutter_smartlook/wireframe/element_descriptors/visible_descriptors/render_image_descriptor.dart';
import 'package:flutter_smartlook/wireframe/element_descriptors/visible_descriptors/render_paragraph_descriptor.dart';
import 'package:flutter_smartlook/wireframe/element_descriptors/visible_descriptors/render_physical_model_descriptor.dart';

class DescriptorsConst {
  String? renderColoredBox;

  final descriptorsMap = <String, DefaultElementDescriptor>{
    getRuntimeType<RenderDecoratedBox>(): const RenderDecoratedBoxDescriptor(),
    getRuntimeType<RenderImage>(): RenderImageDescriptor(),
    getRuntimeType<RenderParagraph>(): RenderParagraphDescriptor(),
    getRuntimeType<RenderPhysicalModel>():
        const RenderPhysicalModelDescriptor(),
    getRuntimeType<RenderPhysicalShape>():
        const RenderPhysicalModelDescriptor(),
    getRuntimeType<RenderEditable>(): RenderParagraphDescriptor(),
    getRuntimeType<RenderCustomPaint>(): RenderCustomPaintDescriptor(),
    getRuntimeType<RenderPadding>(): const RenderPaddingDescriptor(),
    getRuntimeType<RenderOpacity>(): const RenderOpacityDescriptor(),
    getRuntimeType<RenderAndroidView>(): const RenderAndroidViewDescriptor(),
  };

  static String getRuntimeType<T>() => T.toString();
}

/*
"_RenderColoredBox": const RenderColoredBoxDescriptor(),
"_RenderDecoration": const RenderDecorationDescriptor(),
"_RenderMagnification": const RenderMagnifierDescriptor(),
"RenderDecoratedBox": const RenderDecoratedBoxDescriptor(),
"RenderImage": RenderImageDescriptor(),
"RenderParagraph": RenderParagraphDescriptor(),
"RenderPhysicalModel": const RenderPhysicalModelDescriptor(),
"RenderPhysicalShape": const RenderPhysicalModelDescriptor(),
"RenderEditable": RenderParagraphDescriptor(),
"RenderCustomPaint": RenderCustomPaintDescriptor(),
"RenderPadding": const RenderPaddingDescriptor(),
"RenderOpacity": const RenderOpacityDescriptor(),
"RenderAndroidView": const RenderAndroidViewDescriptor(),*/
